commit 5067d7bd31514962af9730b33323b831d87164f8
Author: Martin Helmling <martin.helmling@octosoft.eu>
Date:   Thu Sep 15 08:22:34 2016 +0200

    Artikel-Klassifizierung
    
    Die ursprünglich als "Artikeltyp" bezeichnete Klassifizierung von Artikeln
    Sie dient einer weiteren Gliederung um zum Beispiel den Einkauf vom Verkauf zu trennen, etc.
    
    Gekennzeichnet durch eine Beschreibung (z.B. "Einkauf") und ein Kürzel (z.B. "E")
    Flexibel änderbar und erweiterbar.
    
    - Neue Datenbanktablle und Rose-Objekte, sowie Controller zum Bearbeiten der Tabelle
    
    - Zwei-Zeichen Abkürzung:
    
    Der Typ des Artikel und die Klassifizierung werden durch zwei Buchstaben dargestellt.
    Der erste Buchstabe  ist eine Lokalisierung des Typs des Artikel ('P','A','S') ,
    deutch 'W', 'E', und 'D' für Ware Erzeugnis oder Dienstleistung, ggf. weitere Typen.
    Der zweite Buchstabe ist eine Lokalisierung der Klassifizierungsabkürzung (abbreviation).
    
    Die Abkürzungen sind aus dem Part Presenter abholbar:
    -  SL::Presenter::Part->type_abbreviation($part_type)
    -  SL::Presenter::Part->classification_abbreviation($classification_id)
    
    Wenn im ERP-Dokument nach einer Artikelnummer oder Beschreibung gesucht wird,
    diese in den Stammdaten vorhanden ist,
    aber der Artikeltyp leer oder falsch ist, bzw im Typ for_purchase bzw for_sale nicht gesetzt ist,
    wird die Fehlermeldung "Gesuchter Artikel ist nicht für den Einkauf bzw Verkauf" gemeldet
    
    Anpassung des CSV Import,
    nun wird alternativ zur 'type'-Spalte die 'pclass'-Spalte mit zwei Buchstaben geparsed und entsprechend
    classification_id,assembly sowie inventory_accno_id gesetzt (oder type_id falls neue Implementierung eingebaut).

diff --git a/SL/Controller/CsvImport/Part.pm b/SL/Controller/CsvImport/Part.pm
index ef7e2389a..21a298216 100644
--- a/SL/Controller/CsvImport/Part.pm
+++ b/SL/Controller/CsvImport/Part.pm
@@ -23,7 +23,7 @@ use parent qw(SL::Controller::CsvImport::Base);
 use Rose::Object::MakeMethods::Generic
 (
  scalar                  => [ qw(table makemodel_columns) ],
- 'scalar --get_set_init' => [ qw(bg_by settings parts_by price_factors_by units_by partsgroups_by
+ 'scalar --get_set_init' => [ qw(bg_by settings parts_by price_factors_by classification_by units_by partsgroups_by
                                  warehouses_by bins_by
                                  translation_columns all_pricegroups) ],
 );
@@ -40,6 +40,7 @@ sub set_profile_defaults {
                        article_number_policy     => 'update_prices',
                        shoparticle_if_missing    => '0',
                        part_type                 => 'part',
+                       parts_classification      => 0,
                        default_buchungsgruppe    => ($bugru ? $bugru->id : undef),
                        apply_buchungsgruppe      => 'all',
                       );
@@ -58,6 +59,13 @@ sub init_bg_by {
   return { map { my $col = $_; ( $col => { map { ( $_->$col => $_ ) } @{ $all_bg } } ) } qw(id description) };
 }
 
+sub init_classification_by {
+  my ($self) = @_;
+  my $all_classifications = SL::DB::Manager::PartsClassification->get_all;
+  $_->abbreviation($::locale->text($_->abbreviation)) for @{ $all_classifications };
+  return { map { my $col = $_; ( $col => { map { ( $_->$col => $_ ) } @{ $all_classifications } } ) } qw(id abbreviation) };
+}
+
 sub init_price_factors_by {
   my ($self) = @_;
 
@@ -126,7 +134,7 @@ sub init_settings {
 
   return { map { ( $_ => $self->controller->profile->get($_) ) } qw(apply_buchungsgruppe default_buchungsgruppe article_number_policy
                                                                     sellprice_places sellprice_adjustment sellprice_adjustment_type
-                                                                    shoparticle_if_missing part_type default_unit) };
+                                                                    shoparticle_if_missing part_type classification_id default_unit) };
 }
 
 sub init_all_cvar_configs {
@@ -174,7 +182,7 @@ sub check_objects {
     $i++;
   }
 
-  $self->add_columns(qw(part_type)) if $self->settings->{part_type} eq 'mixed';
+  $self->add_columns(qw(part_type classification_id)) if $self->settings->{part_type} eq 'mixed';
   $self->add_columns(qw(buchungsgruppen_id unit));
   $self->add_columns(map { "${_}_id" } grep { exists $self->controller->data->[0]->{raw_data}->{$_} } qw (price_factor payment partsgroup warehouse bin));
   $self->add_columns(qw(shop)) if $self->settings->{shoparticle_if_missing};
@@ -413,12 +421,30 @@ sub check_part_type {
   # $bg  ||= SL::DB::Buchungsgruppe->new(inventory_accno_id => 1); # does this case ever occur?
 
   my $part_type = $self->settings->{part_type};
-  if ($part_type eq 'mixed') {
+  if ($part_type eq 'mixed' && $entry->{raw_data}->{part_type}) {
     $part_type = $entry->{raw_data}->{part_type} =~ m/^p/i ? 'part'
                : $entry->{raw_data}->{part_type} =~ m/^s/i ? 'service'
                : $entry->{raw_data}->{part_type} =~ m/^assem/i ? 'assembly'
                : $entry->{raw_data}->{part_type} =~ m/^assor/i ? 'assortment'
-               : undef;
+               : $self->settings->{part_type};
+  }
+  my $classification_id = $self->settings->{classification_id};
+
+  if ( $entry->{raw_data}->{pclass} && length($entry->{raw_data}->{pclass}) >= 2 ) {
+      my $abbr1 = substr($entry->{raw_data}->{pclass},0,1);
+      my $abbr2 = substr($entry->{raw_data}->{pclass},1);
+
+      if ( $self->classification_by->{abbreviation}->{$abbr2} ) {
+         my $tmp_classification_id = $self->classification_by->{abbreviation}->{$abbr2}->id;
+         $classification_id = $tmp_classification_id if $tmp_classification_id;
+      }
+      if ($part_type eq 'mixed') {
+          $part_type = $abbr1 eq $::locale->text('Part (typeabbreviation)') ? 'part'
+                     : $abbr1 eq $::locale->text('Service (typeabbreviation)') ? 'service'
+                     : $abbr1 eq $::locale->text('Assembly (typeabbreviation)') ? 'assembly'
+                     : $abbr1 eq $::locale->text('Assortment (typeabbreviation)') ? 'assortment'
+                     :                                        undef;
+      }
   }
 
   # when saving income_accno_id or expense_accno_id use ids from the selected
@@ -443,6 +469,7 @@ sub check_part_type {
   }
 
   $entry->{object}->part_type($part_type);
+  $entry->{object}->classification_id( $classification_id );
 
   return 1;
 }
@@ -699,8 +726,8 @@ sub setup_displayable_columns {
 
   $self->add_displayable_columns({ name => 'bin_id',             description => $::locale->text('Bin (database ID)')                                    },
                                  { name => 'bin',                description => $::locale->text('Bin (name)')                                           },
-                                 { name => 'buchungsgruppen_id', description => $::locale->text('Booking group (database ID)')                         },
-                                 { name => 'buchungsgruppe',     description => $::locale->text('Booking group (name)')                                },
+                                 { name => 'buchungsgruppen_id', description => $::locale->text('Booking group (database ID)')                          },
+                                 { name => 'buchungsgruppe',     description => $::locale->text('Booking group (name)')                                 },
                                  { name => 'description',        description => $::locale->text('Description')                                          },
                                  { name => 'drawing',            description => $::locale->text('Drawing')                                              },
                                  { name => 'ean',                description => $::locale->text('EAN')                                                  },
@@ -721,18 +748,19 @@ sub setup_displayable_columns {
                                  { name => 'partnumber',         description => $::locale->text('Part Number')                                          },
                                  { name => 'partsgroup_id',      description => $::locale->text('Partsgroup (database ID)')                             },
                                  { name => 'partsgroup',         description => $::locale->text('Partsgroup (name)')                                    },
+                                 { name => 'classification_by',  description => $::locale->text('Article classification')  . ' [3]'                     },
                                  { name => 'payment_id',         description => $::locale->text('Payment terms (database ID)')                          },
                                  { name => 'payment',            description => $::locale->text('Payment terms (name)')                                 },
                                  { name => 'price_factor_id',    description => $::locale->text('Price factor (database ID)')                           },
                                  { name => 'price_factor',       description => $::locale->text('Price factor (name)')                                  },
                                  { name => 'rop',                description => $::locale->text('ROP')                                                  },
                                  { name => 'sellprice',          description => $::locale->text('Sellprice')                                            },
-                                 { name => 'shop',               description => $::locale->text('Shop article')                                          },
-                                 { name => 'type',               description => $::locale->text('Article type')  . ' [3]'                             },
+                                 { name => 'shop',               description => $::locale->text('Shop article')                                         },
+                                 { name => 'type',               description => $::locale->text('Article type')  . ' [3]'                               },
                                  { name => 'unit',               description => $::locale->text('Unit (if missing or empty default unit will be used)') },
                                  { name => 've',                 description => $::locale->text('Verrechnungseinheit')                                  },
                                  { name => 'warehouse_id',       description => $::locale->text('Warehouse (database ID)')                              },
-                                 { name => 'warehouse',          description => $::locale->text('Warehouse (name)')                              },
+                                 { name => 'warehouse',          description => $::locale->text('Warehouse (name)')                                     },
                                  { name => 'weight',             description => $::locale->text('Weight')                                               },
                                 );
 
diff --git a/SL/Controller/PartsClassification.pm b/SL/Controller/PartsClassification.pm
new file mode 100644
index 000000000..ced484c6f
--- /dev/null
+++ b/SL/Controller/PartsClassification.pm
@@ -0,0 +1,115 @@
+package SL::Controller::PartsClassification;
+
+use strict;
+
+use parent qw(SL::Controller::Base);
+
+use SL::DB::PartsClassification;
+use SL::Helper::Flash;
+
+use Rose::Object::MakeMethods::Generic
+(
+ scalar => [ qw(parts_classification) ],
+);
+
+__PACKAGE__->run_before('check_auth');
+__PACKAGE__->run_before('load_parts_classification', only => [ qw(edit update destroy) ]);
+
+#
+# actions
+#
+
+sub action_list {
+  my ($self) = @_;
+
+  $self->render('parts_classification/list',
+                title         => $::locale->text('Parts Classifications'),
+                PARTS_CLASSIFICATIONS => SL::DB::Manager::PartsClassification->get_all_sorted);
+}
+
+sub action_new {
+  my ($self) = @_;
+
+  $self->{parts_classification} = SL::DB::PartsClassification->new;
+  $self->render('parts_classification/form', title => $::locale->text('Create a new parts classification'));
+}
+
+sub action_edit {
+  my ($self) = @_;
+  $self->render('parts_classification/form', title => $::locale->text('Edit parts classification'));
+}
+
+sub action_create {
+  my ($self) = @_;
+
+  $self->{parts_classification} = SL::DB::PartsClassification->new;
+  $self->create_or_update;
+}
+
+sub action_update {
+  my ($self) = @_;
+  $self->create_or_update;
+}
+
+sub action_destroy {
+  my ($self) = @_;
+
+  if ( $self->{parts_classification}->id < 5 ) {
+    flash_later('error', $::locale->text('The basic parts classification cannot be deleted.'));
+  }
+  elsif (eval { $self->{parts_classification}->delete; 1; }) {
+    flash_later('info',  $::locale->text('The parts classification has been deleted.'));
+  } else {
+    flash_later('error', $::locale->text('The parts classification is in use and cannot be deleted.'));
+  }
+
+  $self->redirect_to(action => 'list');
+}
+
+sub action_reorder {
+  my ($self) = @_;
+
+  SL::DB::PartsClassification->reorder_list(@{ $::form->{parts_classification_id} || [] });
+
+  $self->render(\'', { type => 'json' });
+}
+
+#
+# filters
+#
+
+sub check_auth {
+  $::auth->assert('config');
+}
+
+#
+# helpers
+#
+
+sub create_or_update {
+  my $self   = shift;
+  my $is_new = !$self->{parts_classification}->id;
+  my $params = delete($::form->{parts_classification}) || { };
+
+  $self->{parts_classification}->assign_attributes(%{ $params });
+
+  my @errors = $self->{parts_classification}->validate;
+
+  if (@errors) {
+    flash('error', @errors);
+    $self->render('parts_classification/form', title => $is_new ? $::locale->text('Create a new parts classification') : $::locale->text('Edit parts classification'));
+    return;
+  }
+
+  $self->{parts_classification}->save;
+
+  flash_later('info', $is_new ? $::locale->text('The parts classification has been created.') : $::locale->text('The parts classification has been saved.'));
+  $self->redirect_to(action => 'list');
+}
+
+sub load_parts_classification {
+  my ($self) = @_;
+  $self->{parts_classification} = SL::DB::PartsClassification->new(id => $::form->{id})->load;
+}
+
+1;
diff --git a/SL/DB/Helper/Mappings.pm b/SL/DB/Helper/Mappings.pm
index 7d1907dfa..d61f59f3a 100644
--- a/SL/DB/Helper/Mappings.pm
+++ b/SL/DB/Helper/Mappings.pm
@@ -153,6 +153,7 @@ my %kivitendo_package_names = (
   oe                             => 'order',
   parts                          => 'part',
   partsgroup                     => 'parts_group',
+  parts_classifications          => 'PartsClassification',
   parts_price_history            => 'PartsPriceHistory',
   payment_terms                  => 'payment_term',
   periodic_invoices              => 'periodic_invoice',
diff --git a/SL/DB/MetaSetup/Part.pm b/SL/DB/MetaSetup/Part.pm
index 65cd85da2..7c79e2e0e 100644
--- a/SL/DB/MetaSetup/Part.pm
+++ b/SL/DB/MetaSetup/Part.pm
@@ -12,6 +12,7 @@ __PACKAGE__->meta->columns(
   bin_id             => { type => 'integer' },
   bom                => { type => 'boolean', default => 'false' },
   buchungsgruppen_id => { type => 'integer' },
+  classification_id  => { type => 'integer', default => '0' },
   description        => { type => 'text' },
   drawing            => { type => 'text' },
   ean                => { type => 'text' },
@@ -63,6 +64,11 @@ __PACKAGE__->meta->foreign_keys(
     key_columns => { buchungsgruppen_id => 'id' },
   },
 
+  classification => {
+    class       => 'SL::DB::PartsClassification',
+    key_columns => { classification_id => 'id' },
+  },
+
   partsgroup => {
     class       => 'SL::DB::PartsGroup',
     key_columns => { partsgroup_id => 'id' },
diff --git a/SL/IC.pm b/SL/IC.pm
index 2cf7996fb..2163bf817 100644
--- a/SL/IC.pm
+++ b/SL/IC.pm
@@ -85,6 +85,7 @@ sub get_part {
     # retrieve assembly items
     $query =
       qq|SELECT p.id, p.partnumber, p.description,
+           p.classification_id,
            p.sellprice, p.lastcost, p.weight, a.qty, a.bom, p.unit,
            pg.partsgroup, p.price_factor_id, pfac.factor AS price_factor
          FROM parts p
@@ -101,6 +102,8 @@ sub get_part {
       foreach my $key (keys %{$ref}) {
         $form->{"${key}_$form->{assembly_rows}"} = $ref->{$key};
       }
+      $form->{"type_and_classific_$form->{assembly_rows}"} = $::request->presenter->type_abbreviation($ref->{part_type}).
+                                                             $::request->presenter->classification_abbreviation($ref->{classification_id});
     }
     $sth->finish;
 
@@ -334,6 +337,7 @@ sub _save {
          partnumber = ?,
          description = ?,
          makemodel = ?,
+         classification_id = ?,
          listprice = ?,
          sellprice = ?,
          lastcost = ?,
@@ -367,6 +371,7 @@ sub _save {
   @values = ($form->{partnumber},
              $form->{description},
              $makemodel ? 't' : 'f',
+             $form->{classification_id},
              $form->{listprice},
              $form->{sellprice},
              $form->{lastcost},
@@ -642,6 +647,7 @@ sub assembly_item {
 
   my $query =
     qq|SELECT p.id, p.partnumber, p.description, p.sellprice,
+       p.classification_id,
        p.weight, p.onhand, p.unit, pg.partsgroup, p.lastcost,
        p.price_factor_id, pfac.factor AS price_factor, p.notes as longdescription
        FROM parts p
@@ -723,7 +729,7 @@ sub all_parts {
 #  my @other_flags          = qw(onhand); # ToDO: implement these
 #  my @inactive_flags       = qw(l_subtotal short l_linetotal);
 
-  my @select_tokens = qw(id factor);
+  my @select_tokens = qw(id factor part_type classification_id);
   my @where_tokens  = qw(1=1);
   my @group_tokens  = ();
   my @bind_vars     = ();
@@ -800,7 +806,7 @@ sub all_parts {
     insertdate         => 'itime::DATE',
   );
 
-  if (($form->{searchitems} eq 'assembly') && $form->{l_lastcost}) {
+  if ($form->{l_assembly} && $form->{l_lastcost}) {
     @simple_l_switches = grep { $_ ne 'lastcost' } @simple_l_switches;
   }
 
@@ -890,10 +896,22 @@ sub all_parts {
     push @select_tokens, $_;
   }
 
-  for ($form->{searchitems}) {
-    push @where_tokens, "p.part_type = 'part'"     if /part/;
-    push @where_tokens, "p.part_type = 'service'"  if /service/;
-    push @where_tokens, "p.part_type = 'assembly'" if /assembly/;
+  # Oder Bedingungen fuer Ware Dienstleistung Erzeugnis:
+  if ($form->{l_part} || $form->{l_assembly} || $form->{l_service}) {
+      my @or_tokens = ();
+      push @or_tokens, "p.part_type = 'service'"  if $form->{l_service};
+      push @or_tokens, "p.part_type = 'assembly'" if $form->{l_assembly};
+      push @or_tokens, "p.part_type = 'part'"     if $form->{l_part};
+      push @where_tokens, join ' OR ', map { "($_)" } @or_tokens;
+  }
+  else {
+      # gar keine Teile
+      push @where_tokens, q|'F' = 'T'|;
+  }
+
+  if ( $form->{classification_id} > 0 ) {
+    push @where_tokens, "p.classification_id = ?";
+    push @bind_vars, $form->{classification_id};
   }
 
   for ($form->{itemstatus}) {
@@ -951,7 +969,7 @@ sub all_parts {
 
   push @select_tokens, @qsooqr_flags, 'quotation', 'cv', 'ioi.id', 'ioi.ioi'  if $bsooqr;
   push @select_tokens, @deliverydate_flags                                    if $bsooqr && $form->{l_deliverydate};
-  push @select_tokens, $q_assembly_lastcost                                   if ($form->{searchitems} eq 'assembly') && $form->{l_lastcost};
+  push @select_tokens, $q_assembly_lastcost                                   if $form->{l_assembly} && $form->{l_lastcost};
   push @bsooqr_tokens, q|module = 'ir' AND NOT ioi.assemblyitem|              if $form->{bought};
   push @bsooqr_tokens, q|module = 'is' AND NOT ioi.assemblyitem|              if $form->{sold};
   push @bsooqr_tokens, q|module = 'oe' AND NOT quotation AND cv = 'customer'| if $form->{ordered};
@@ -1049,7 +1067,7 @@ sub all_parts {
   # post processing for assembly parts lists (bom)
   # for each part get the assembly parts and add them into the partlist.
   my @assemblies;
-  if ($form->{searchitems} eq 'assembly' && $form->{bom}) {
+  if ($form->{l_assembly} && $form->{bom}) {
     $query =
       qq|SELECT p.id, p.partnumber, p.description, a.qty AS onhand,
            p.unit, p.notes, p.itime::DATE as insertdate,
@@ -1079,7 +1097,7 @@ sub all_parts {
     $form->{parts} = \@assemblies;
   }
 
-  if ($form->{l_pricegroups} ) {
+  if ($form->{l_pricegroups} && SL::DB::Manager::Price->get_all_count() > 0 ) {
     my $query = <<SQL;
        SELECT parts_id, price, pricegroup_id
        FROM prices
@@ -1096,8 +1114,7 @@ SQL
       }
       $sth->finish;
     }
-  };
-
+  }
 
   $main::lxdebug->leave_sub();
 
@@ -1393,7 +1410,8 @@ sub get_parts {
   }
 
   my $query =
-    qq|SELECT id, partnumber, description, unit, sellprice
+    qq|SELECT id, partnumber, description, unit, sellprice,
+       classification_id
        FROM parts
        WHERE $where ORDER BY $order|;
 
@@ -1406,6 +1424,8 @@ sub get_parts {
     }
 
     $j++;
+    $form->{"type_and_classific_$j"} = $::request->presenter->type_abbreviation($ref->{part_type}).
+                                       $::request->presenter->classification_abbreviation($ref->{classification_id});
     $form->{"id_$j"}          = $ref->{id};
     $form->{"partnumber_$j"}  = $ref->{partnumber};
     $form->{"description_$j"} = $ref->{description};
@@ -1733,12 +1753,14 @@ sub prepare_parts_for_printing {
   for my $i (1..$rowcount) {
     my $id = $form->{"${prefix}${i}"};
     next unless $id;
-
-    push @{ $template_arrays{part_type} },  $parts_by_id{$id}->type;
+    my $prt = $parts_by_id{$id};
+    my $type_abbr = $::request->presenter->type_abbreviation($prt->part_type);
+    push @{ $template_arrays{part_type} }, $type_abbr;
+    push @{ $template_arrays{type_and_classific}},  $type_abbr.$::request->presenter->classification_abbreviation($prt->classification_id);
   }
 
-  return %template_arrays;
   $main::lxdebug->leave_sub();
+  return %template_arrays;
 }
 
 sub normalize_text_blocks {
@@ -1760,5 +1782,4 @@ sub normalize_text_blocks {
    $main::lxdebug->leave_sub();
 }
 
-
 1;
diff --git a/SL/IR.pm b/SL/IR.pm
index a0bf6cdf6..7518ed4b5 100644
--- a/SL/IR.pm
+++ b/SL/IR.pm
@@ -1020,6 +1020,7 @@ sub retrieve_invoice {
         i.description, i.longdescription, i.qty, i.fxsellprice AS sellprice, i.parts_id AS id, i.unit, i.deliverydate, i.project_id, i.serialnumber,
         i.price_factor_id, i.price_factor, i.marge_price_factor, i.discount, i.active_price_source, i.active_discount_source,
         p.partnumber, p.part_type, pr.projectnumber, pg.partsgroup
+        ,p.classification_id
 
         FROM invoice i
         JOIN parts p ON (i.parts_id = p.id)
@@ -1279,6 +1280,7 @@ sub retrieve_item {
          p.notes AS partnotes, p.notes AS longdescription, p.not_discountable,
          p.inventory_accno_id, p.price_factor_id,
          p.ean,
+         p.classification_id,
 
          pfac.factor AS price_factor,
 
@@ -1294,6 +1296,7 @@ sub retrieve_item {
          c3.new_chart_id                  AS expense_new_chart,
          date($transdate) - c3.valid_from AS expense_valid,
 
+         pt.used_for_purchase AS used_for_purchase,
          pg.partsgroup
 
        FROM parts p
@@ -1310,6 +1313,7 @@ sub retrieve_item {
            FROM taxzone_charts tc
            WHERE tc.taxzone_id = '$taxzone_id' and tc.buchungsgruppen_id = p.buchungsgruppen_id) = c3.id)
        LEFT JOIN partsgroup pg ON (pg.id = p.partsgroup_id)
+       LEFT JOIN parts_classifications pt ON (pt.id = p.classification_id)
        LEFT JOIN price_factors pfac ON (pfac.id = p.price_factor_id)
        WHERE $where|;
   my $sth = prepare_execute_query($form, $dbh, $query, @values);
@@ -1328,6 +1332,7 @@ sub retrieve_item {
   map { push @{ $_ }, prepare_query($form, $dbh, $_->[0]) } @translation_queries;
 
   $form->{item_list} = [];
+  my $has_wrong_pclass = 0;
   while (my $ref = $sth->fetchrow_hashref("NAME_lc")) {
 
     if ($mm_by_id{$ref->{id}}) {
@@ -1338,7 +1343,13 @@ sub retrieve_item {
     if (($::form->{"partnumber_$i"} ne '') && ($ref->{ean} eq $::form->{"partnumber_$i"})) {
       push @{ $ref->{matches} ||= [] }, $::locale->text('EAN') . ': ' . $ref->{ean};
     }
+    $ref->{type_and_classific} = $::request->presenter->type_abbreviation($ref->{part_type}).
+                                 $::request->presenter->classification_abbreviation($ref->{classification_id});
 
+    if (! $ref->{used_for_purchase} ) {
+       $has_wrong_pclass = 2;
+       next;
+    }
     # In der Buchungsgruppe ist immer ein Bestandskonto verknuepft, auch wenn
     # es sich um eine Dienstleistung handelt. Bei Dienstleistungen muss das
     # Buchungskonto also aus dem Ergebnis rausgenommen werden.
@@ -1408,12 +1419,13 @@ sub retrieve_item {
   $sth->finish();
   $_->[1]->finish for @translation_queries;
 
+  $form->{is_wrong_pclass} = $has_wrong_pclass;
   foreach my $item (@{ $form->{item_list} }) {
     my $custom_variables = CVar->get_custom_variables(module   => 'IC',
                                                       trans_id => $item->{id},
                                                       dbh      => $dbh,
                                                      );
-
+    $form->{is_wrong_pclass} = 0; # one correct type
     map { $item->{"ic_cvar_" . $_->{name} } = $_->{value} } @{ $custom_variables };
   }
 
diff --git a/SL/IS.pm b/SL/IS.pm
index 568694720..b55cd7f28 100644
--- a/SL/IS.pm
+++ b/SL/IS.pm
@@ -2003,6 +2003,7 @@ sub _retrieve_invoice {
            i.project_id, i.serialnumber, i.pricegroup_id, i.ordnumber, i.donumber, i.transdate, i.cusordnumber, i.subtotal, i.lastcost,
            i.price_factor_id, i.price_factor, i.marge_price_factor, i.active_price_source, i.active_discount_source,
            p.partnumber, p.part_type, p.notes AS partnotes, p.formel, p.listprice,
+           p.classification_id,
            pr.projectnumber, pg.partsgroup, prg.pricegroup
 
          FROM invoice i
@@ -2300,6 +2301,7 @@ sub retrieve_item {
          p.id, p.partnumber, p.description, p.sellprice,
          p.listprice, p.part_type, p.lastcost,
          p.ean, p.notes,
+         p.classification_id,
 
          c1.accno AS inventory_accno,
          c1.new_chart_id AS inventory_new_chart,
@@ -2319,7 +2321,7 @@ sub retrieve_item {
          p.price_factor_id, p.weight,
 
          pfac.factor AS price_factor,
-
+         pt.used_for_sale AS used_for_sale,
          pg.partsgroup
 
        FROM parts p
@@ -2336,6 +2338,7 @@ sub retrieve_item {
            FROM taxzone_charts tc
            WHERE tc.buchungsgruppen_id = p.buchungsgruppen_id and tc.taxzone_id = ${taxzone_id}) = c3.id)
        LEFT JOIN partsgroup pg ON (pg.id = p.partsgroup_id)
+       LEFT JOIN parts_classifications pt ON (pt.id = p.classification_id)
        LEFT JOIN price_factors pfac ON (pfac.id = p.price_factor_id)
        WHERE $where|;
   my $sth = prepare_execute_query($form, $dbh, $query, @values);
@@ -2353,6 +2356,7 @@ sub retrieve_item {
                                    LIMIT 1| ] );
   map { push @{ $_ }, prepare_query($form, $dbh, $_->[0]) } @translation_queries;
 
+  my $has_wrong_pclass = 0;
   while (my $ref = $sth->fetchrow_hashref('NAME_lc')) {
 
     if ($mm_by_id{$ref->{id}}) {
@@ -2364,6 +2368,12 @@ sub retrieve_item {
       push @{ $ref->{matches} ||= [] }, $::locale->text('EAN') . ': ' . $ref->{ean};
     }
 
+    $ref->{type_and_classific} = $::request->presenter->type_abbreviation($ref->{part_type}).
+                                 $::request->presenter->classification_abbreviation($ref->{classification_id});
+    if (! $ref->{used_for_sale} ) {
+        $has_wrong_pclass = 1;
+        next;
+    }
     # In der Buchungsgruppe ist immer ein Bestandskonto verknuepft, auch wenn
     # es sich um eine Dienstleistung handelt. Bei Dienstleistungen muss das
     # Buchungskonto also aus dem Ergebnis rausgenommen werden.
@@ -2447,15 +2457,15 @@ sub retrieve_item {
   $sth->finish;
   $_->[1]->finish for @translation_queries;
 
+  $form->{is_wrong_pclass} = $has_wrong_pclass;
   foreach my $item (@{ $form->{item_list} }) {
     my $custom_variables = CVar->get_custom_variables(module   => 'IC',
                                                       trans_id => $item->{id},
                                                       dbh      => $dbh,
                                                      );
-
+    $form->{is_wrong_pclass} = 0; # one correct type
     map { $item->{"ic_cvar_" . $_->{name} } = $_->{value} } @{ $custom_variables };
   }
-
   $main::lxdebug->leave_sub();
 }
 
diff --git a/SL/OE.pm b/SL/OE.pm
index d347d5b2f..24e88f004 100644
--- a/SL/OE.pm
+++ b/SL/OE.pm
@@ -1094,6 +1094,7 @@ sub _retrieve {
            c3.accno AS expense_accno,   c3.new_chart_id AS expense_new_chart,   date($transdate) - c3.valid_from as expense_valid,
            oe.ordnumber AS ordnumber_oe, oe.transdate AS transdate_oe, oe.cusordnumber AS cusordnumber_oe,
            p.partnumber, p.part_type, p.listprice, o.description, o.qty,
+           p.classification_id,
            o.sellprice, o.parts_id AS id, o.unit, o.discount, p.notes AS partnotes, p.part_type,
            o.reqdate, o.project_id, o.serialnumber, o.ship, o.lastcost,
            o.ordnumber, o.transdate, o.cusordnumber, o.subtotal, o.longdescription,
diff --git a/SL/Presenter/Part.pm b/SL/Presenter/Part.pm
index 1f96cbe7b..c3bbea2bc 100644
--- a/SL/Presenter/Part.pm
+++ b/SL/Presenter/Part.pm
@@ -3,9 +3,10 @@ package SL::Presenter::Part;
 use strict;
 
 use SL::DB::Part;
+use SL::DB::Manager::PartsClassification;
 
 use Exporter qw(import);
-our @EXPORT = qw(part_picker part);
+our @EXPORT = qw(part_picker part select_classification classification_abbreviation type_abbreviation type_and_classification);
 
 use Carp;
 
@@ -46,6 +47,48 @@ sub part_picker {
   $self->html_tag('span', $ret, class => 'part_picker');
 }
 
+#
+# Must be addapted to new type table
+#
+sub type_abbreviation {
+  my ($self, $part_type) = @_;
+  $main::lxdebug->message(LXDebug->DEBUG2(),"parttype=".$part_type);
+  return $::locale->text('Assembly (typeabbreviation)')   if $part_type eq 'assembly';
+  return $::locale->text('Part (typeabbreviation)')       if $part_type eq 'part';
+  return $::locale->text('Assortment (typeabbreviation)') if $part_type eq 'assortment';
+  return $::locale->text('Service (typeabbreviation)');
+}
+
+#
+# Translations for Abbreviations:
+#
+# $::locale->text('None (typeabbreviation)')
+# $::locale->text('Purchase (typeabbreviation)')
+# $::locale->text('Sales (typeabbreviation)')
+# $::locale->text('Merchandise (typeabbreviation)')
+# $::locale->text('Production (typeabbreviation)')
+#
+# and for descriptions
+# $::locale->text('Purchase')
+# $::locale->text('Sales')
+# $::locale->text('Merchandise')
+# $::locale->text('Production')
+
+sub classification_abbreviation {
+  my ($self, $id) = @_;
+  $main::lxdebug->message(LXDebug->DEBUG2(),"classif=".$id);
+  return $::locale->text(SL::DB::Manager::PartsClassification->get_abbreviation($id));
+}
+
+sub select_classification {
+  my ($self, $name, %attributes) = @_;
+  $attributes{value_key} = 'id';
+  $attributes{title_key} = 'description';
+  my $collection = SL::DB::Manager::PartsClassification->get_all_sorted();
+  $_->description($::locale->text($_->description)) for @{ $collection };
+  return $self->select_tag( $name, $collection, %attributes );
+}
+
 1;
 
 __END__
